﻿Type=Activity
Version=5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Private template As String

End Sub

Sub Globals
	Private Spinner1 As Spinner
	Private WebView1 As WebView

End Sub

Sub Activity_Create(FirstTime As Boolean)
	If FirstTime Then
		template = File.ReadString(File.DirAssets, "template.html")
	End If
	Activity.LoadLayout("1")
	WebView1.ZoomEnabled = False
	Spinner1.AddAll(Array As String("Bar", "Line", "Pie", "Geo"))
	Spinner1.SelectedIndex = 0
	Spinner1_ItemClick(0, Spinner1.GetItem(0))

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
Sub Spinner1_ItemClick (Position As Int, Value As Object)
	Dim cols As List
	cols.Initialize
	Dim rows As List
	rows.Initialize
	Dim options As Map
	options.Initialize
	Select Value
		Case "Pie"
			CreatePieChartData(cols, rows)
			CreatePieChartOptions(options)
		Case "Bar"
			CreateBarChartData(cols, rows)
			CreateBarChartOptions(options)
		Case "Line"
			CreateLineChartData(cols, rows)
			CreateLineChartOptions(options)
		Case "Geo"
			CreateGeoChartData(cols, rows)
	End Select
	Dim data As Map
	data.Initialize
	data.Put("cols", cols)
	data.Put("rows", rows)
	Dim jg As JSONGenerator
	Dim html As String = template
	html = html.Replace("$TYPE$", Value & "Chart")
	jg.Initialize(options)
	html = html.Replace("$OPTIONS$", jg.ToString)
	jg.Initialize(data)	
	html = html.Replace("$DATA$", jg.ToString)
	WebView1.LoadHtml(html)
	'Log(html)
End Sub

Private Sub CreateColumn(id As String, Label As String, dataType As String) As Map
	Dim m As Map
	m.Initialize
	m.Put("id", id)
	m.Put("label", Label)
	m.Put("type", dataType)
	Return m
End Sub

Private Sub CreateRow(Values As List) As Map
	Dim C As Map
	C.Initialize
	Dim vr As List
	vr.Initialize
	C.Put("c", vr)
	For Each o As Object In Values
		Dim m As Map
		m.Initialize
		m.Put("v", o)
		vr.Add(m)
	Next
	Return C
End Sub

Private Sub CreatePieChartData(cols As List, rows As List)
	cols.Add(CreateColumn("", "Topping", "string"))
	cols.Add(CreateColumn("", "Slices", "number"))
	rows.Add(CreateRow(Array As Object("Mushrooms", 3)))
	rows.Add(CreateRow(Array As Object("Onions", 1)))
	rows.Add(CreateRow(Array As Object("Olives", 1)))
	rows.Add(CreateRow(Array As Object("Zucchini", 1)))
	rows.Add(CreateRow(Array As Object("Pepperoni", 2)))
End Sub

Private Sub CreatePieChartOptions (options As Map)
	options.Put("title", "Pizza")
	options.Put("is3D", False)
End Sub

Private Sub CreateBarChartData (cols As List, rows As List)
	cols.Add(CreateColumn("", "Year", "string"))
	cols.Add(CreateColumn("", "Sales", "number"))
	cols.Add(CreateColumn("", "Expenses", "number"))
	rows.Add(CreateRow(Array As Object("2004", 1000, 400)))
	rows.Add(CreateRow(Array As Object("2005", 1170, 460)))
	rows.Add(CreateRow(Array As Object("2006", 660, 1120)))
	rows.Add(CreateRow(Array As Object("2007", 1030, 540)))
End Sub

Private Sub CreateBarChartOptions (options As Map)
	options.Put("title", "Company Performance")
	Dim m As Map
	m.Initialize
	m.Put("title", "Year")
	options.Put("vAxis", m)
End Sub

Private Sub CreateLineChartData (cols As List, rows As List)
	cols.Add(CreateColumn("", "Year", "string"))
	cols.Add(CreateColumn("", "Sales", "number"))
	cols.Add(CreateColumn("", "Expenses", "number"))
	rows.Add(CreateRow(Array As Object("2004", 1000, 400)))
	rows.Add(CreateRow(Array As Object("2005", 1170, 460)))
	rows.Add(CreateRow(Array As Object("2006", 660, 1120)))
	rows.Add(CreateRow(Array As Object("2007", 1030, 540)))
End Sub

Private Sub CreateLineChartOptions (options As Map)
	options.Put("title", "Company Performance")
End Sub

Private Sub CreateGeoChartData (cols As List, rows As List)
	cols.Add(CreateColumn("", "Country", "string"))
	cols.Add(CreateColumn("", "Popularity", "number"))
	rows.Add(CreateRow(Array As Object("Germany", 200)))
	rows.Add(CreateRow(Array As Object("United States", 300)))
	rows.Add(CreateRow(Array As Object("Brazil", 400)))
	rows.Add(CreateRow(Array As Object("Canada", 500)))
	rows.Add(CreateRow(Array As Object("France", 600)))
	rows.Add(CreateRow(Array As Object("RU", 700)))
End Sub

